/**
 * My Title
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.FilterableListOfProblem
import io.swagger.client.models.Problem
import io.swagger.client.models.ProblemsRequest

import io.swagger.client.infrastructure.*

class ProblemsApi(basePath: kotlin.String = "http://localhost:8080") : ApiClient(basePath) {

    /**
     * 
     * 
     * @param id  
     * @return Problem
     */
    @Suppress("UNCHECKED_CAST")
    fun problemsGetProblem(id: kotlin.String): Problem {
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/problems/{id}".replace("{" + "id" + "}", "$id")
        )
        val response = request<Problem>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as Problem
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return FilterableListOfProblem
     */
    @Suppress("UNCHECKED_CAST")
    fun problemsGetProblems(body: ProblemsRequest): FilterableListOfProblem {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/problems"
        )
        val response = request<FilterableListOfProblem>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as FilterableListOfProblem
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param id  
     * @param status  (optional)
     * @return void
     */
    fun problemsUpdateProblem(id: kotlin.String, status: kotlin.Boolean? = null): Unit {
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (status != null) {
                put("status", listOf(status.toString()))
            }
        }
        val localVariableConfig = RequestConfig(
                RequestMethod.PATCH,
                "/api/problems/{id}".replace("{" + "id" + "}", "$id"), query = localVariableQuery
        )
        val response = request<Any?>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> Unit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
